image: node:8-alpine

stages:
  - requirements
  - test
  - analyze
  - docker
  - deploy
  
services:
  - docker:stable-dind
  - mongo:4.2-rc-bionic
  - redis:5-alpine
  
get_dependencies:
  stage: requirements
  script:
   - apk update
   - apk --no-cache add --virtual builds-deps build-base python  
   - npm install
  cache:
   paths:
    - node_modules/
  artifacts:
    paths:
      - node_modules/

mocha:
  stage: test
  script:
    - npm install -g mocha nyc
    - npm run test
  artifacts:
    paths:
      - coverage/
      
analyze:
  stage: analyze
  image: ciricihq/gitlab-sonar-scanner
  script:
    - sonar-scanner -Dsonar.host.url=https://sonarqube.mess-enkrypt.xyz -Dsonar.gitlab.project_id=$CI_PROJECT_ID -Dsonar.projectVersion=$CI_BUILD_ID -Dsonar.gitlab.commit_sha=$CI_BUILD_REF -Dsonar.gitlab.ref_name=$CI_BUILD_REF_NAME -Dsonar.login=$SONARTOKEN

docker-branch:
  stage: docker
  image: docker
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD registry.gitlab.com
    - docker build -f DockerfileCI -t registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_SHORT_SHA .
    - docker push registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_SHORT_SHA
  only:
    - feature/*
    
docker:
  stage: docker
  image: docker
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD registry.gitlab.com
    - docker build -f DockerfileCI -t registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_REF_NAME .
    - docker tag registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_REF_NAME registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:latest
    - docker push registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_REF_NAME
    - docker push registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:latest
  only:
    - develop
    - master
  allow_failure: false
  
deploy-dev:
  stage: deploy
  image: alpine
  script:
    - apk update
    - 'which ssh-agent || ( apk add openssh-client )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY_DEPLOY" > deploy.pem
    - chmod 400 deploy.pem
    - ssh-add deploy.pem
    - mkdir -p ~/.ssh
    - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ssh ci@mess-enkrypt.loiu92.com "cd /home/ci/mess-enkrypt-api-develop/ && docker-compose pull api-develop && docker-compose up -d api-develop"
  only:
    - develop

deploy-master:
  stage: deploy
  image: alpine
  script:
    - apk update
    - 'which ssh-agent || ( apk add openssh-client )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY_DEPLOY" > deploy.pem
    - chmod 400 deploy.pem
    - ssh-add deploy.pem
    - mkdir -p ~/.ssh
    - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ssh ci@mess-enkrypt.loiu92.com "cd /home/ci/mess-enkrypt-api/ && docker-compose pull api-master && docker-compose up -d api-master"
  only:
    - master
  when: manual
